<?php

declare(strict_types=1);

namespace Drupal\basicshib\Entity;

use Drupal\Core\Config\Entity\ConfigEntityBase;
use Drupal\basicshib\AuthFilterInterface;

/**
 * Defines the auth-filter entity type.
 *
 * @ConfigEntityType(
 *   id = "auth_filter",
 *   label = @Translation("auth-filter"),
 *   label_collection = @Translation("auth-filters"),
 *   label_singular = @Translation("auth-filter"),
 *   label_plural = @Translation("auth-filters"),
 *   label_count = @PluralTranslation(
 *     singular = "@count auth-filter",
 *     plural = "@count auth-filters",
 *   ),
 *   handlers = {
 *     "list_builder" = "Drupal\basicshib\AuthFilterListBuilder",
 *     "form" = {
 *       "add" = "Drupal\basicshib\Form\AuthFilterForm",
 *       "edit" = "Drupal\basicshib\Form\AuthFilterForm",
 *       "delete" = "Drupal\Core\Entity\EntityDeleteForm",
 *     },
 *   },
 *   config_prefix = "auth_filter",
 *   admin_permission = "administer auth_filter",
 *   links = {
 *     "collection" = "/admin/structure/auth-filter",
 *     "add-form" = "/admin/structure/auth-filter/add",
 *     "edit-form" = "/admin/structure/auth-filter/{auth_filter}",
 *     "delete-form" = "/admin/structure/auth-filter/{auth_filter}/delete",
 *   },
 *   entity_keys = {
 *     "id" = "id",
 *     "label" = "label",
 *     "uuid" = "uuid",
 *   },
 *   config_export = {
 *     "id",
 *     "label",
 *     "allow",
 *     "error",
 *     "description",
 *   },
 * )
 */
final class AuthFilter extends ConfigEntityBase implements AuthFilterInterface {

  /**
   * The example ID.
   */
  protected string $id;

  /**
   * The example label.
   */
  protected string $label;

  /**
   * The example label.
   */
  protected string $allow;

  /**
   * The example label.
   */
  protected string $error;

  /**
   * The example description.
   */
  protected string $description;

}
