<?php

namespace Drupal\basicshib\Plugin\basicshib\grouper;

use Drupal\basicshib\Plugin\GrouperPluginInterface;
use Drupal\Core\Entity\EntityStorageInterface;
use Drupal\Core\Plugin\ContainerFactoryPluginInterface;
use Symfony\Component\DependencyInjection\ContainerInterface;

/**
 * Class GrouperPluginDefault.
 *
 * @package Drupal\basicshib\Plugin\basicshib\grouper
 *
 * @BasicShibGrouper(
 *   id = "grouper_default",
 *   title = "grouper"
 * )
 */
class GrouperPluginDefault implements GrouperPluginInterface {//, ContainerFactoryPluginInterface {

  /**
   * The entity storage class.
   *
   * @var EntityStorageInterface
   */
  protected array $grouper;

//  public function __construct($grouper) {
  public function __construct() {
    $this->grouper = \Drupal::service('config.factory')->listAll($prefix = "basicshib.authorization");
//    $this->grouper = $grouper;
  }

  /**
   * {@inheritDoc}
   *
   * @param ContainerInterface $container
   * @param array $configuration
   * @param string $plugin_id
   * @param string $plugin_definition
   *
   * @return GrouperPluginDefault instance
   */
//  public static function create(ContainerInterface $container, array $configuration, $plugin_id, $plugin_definition): GrouperPluginDefault {
//    return new static(
//          // $container->get('entity_type.manager')->getStorage('grouper_role')
//      );
//  }

  /**
   * {@inheritDoc}
   */
  public function getMap($userGroups): array {
    $roleMap = [];
    // TODO: Add ability to include authenticated user in query. inclusion set by checkbox on basicshib settings form.
    // Read the grouper configuration entities (what 'groups' are assigned to
    // each drupal role, except the roles that are assigned by default or have
    // been specifically excluded on the Grouper settings form. The grouper
    // configuration entity stores all the 'groups' assigned to a role in a
    // string.
    $roleGroups = \Drupal::configFactory()->getEditable('basicshib.authorization.' . 'administrator')->get('policy');
    // Loop through the grouper configuration entities and if the user's
    // assigned Drupal role has one of the grouper groups assigned to the role
    // add that role to the array being returned.
    if (str_contains($roleGroups, PHP_EOL)) {
      $roleGroups = explode(PHP_EOL, $roleGroups);
    } elseif (str_contains($roleGroups, ",")) {
      $roleGroups = explode(PHP_EOL, $roleGroups);
    }
    foreach ($roleGroups as $roleId) {
      $roleId = trim($roleId);
      foreach ($userGroups as $userGroup) {
        if (strpos($roleId, $userGroup) !== FALSE) {
          $roleMap[] = $roleId;
          break;
        }
      }
    }

    return $roleMap;
  }

}
